import stddraw
import sys

def midpoint(x1, y1, x2, y2):
    return [(x1+x2)/2, (y1+y2)/2]

def sierpinski(points, degree):
    if degree == 0: # Base Condition
        return
    
    stddraw.line(points[0][0], points[0][1], points[1][0], points[1][1])
    stddraw.line(points[1][0], points[1][1], points[2][0], points[2][1])
    stddraw.line(points[2][0], points[2][1], points[0][0], points[0][1])

    sierpinski([[points[0][0], points[0][1]], 
                    midpoint(points[0][0], points[0][1], points[1][0], points[1][1]),
                    midpoint(points[0][0], points[0][1], points[2][0], points[2][1])],
                    degree - 1)
    
    sierpinski([[points[1][0], points[1][1]], 
                    midpoint(points[1][0], points[1][1], points[0][0], points[0][1]),
                    midpoint(points[1][0], points[1][1], points[2][0], points[2][1])],
                    degree - 1)
    
    sierpinski([[points[2][0], points[2][1]], 
                    midpoint(points[2][0], points[2][1], points[1][0], points[1][1]),
                    midpoint(points[2][0], points[2][1], points[0][0], points[0][1])],
                    degree - 1)

k = int(sys.argv[1])
stddraw.setXscale(-10, 10)
stddraw.setYscale(-10, 10)
points = [[-10, -5],
          [0, 10],
          [10, -5]]
sierpinski(points, k)
stddraw.show()